Debian Bug report logs - #574396
please set enable-meta-key (_rl_enable_meta) sanely

version graph

Package: bash; Maintainer for bash is Matthias Klose <doko@debian.org>; Source for bash is src:bash.

Reported by: "Aaron M. Ucko" <ucko@debian.org>

Date: Wed, 17 Mar 2010 22:12:01 UTC

Severity: important

Merged with 577010

Found in version bash/4.1-2

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, ucko@debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Wed, 17 Mar 2010 22:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Aaron M. Ucko" <ucko@debian.org>:
New Bug report received and forwarded. Copy sent to ucko@debian.org, Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 17 Mar 2010 22:12:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Aaron M. Ucko" <ucko@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: meta no longer sends escape even with eightBitInput: false
Date: Wed, 17 Mar 2010 18:09:01 -0400
Package: xterm
Version: 256-1
Severity: normal

My X resources set XTerm*eightBitInput: false, because (as noted in
#326200 and #534192) that's generally a saner choice nowadays.
However, a recent upgrade (presumably to xterm itself) broke that;
alt-key combinations now yield non-ASCII characters rather than the
expected escape sequences, which I have to remind myself to type
explicitly. :-/

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-3-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages xterm depends on:
ii  libc6                     2.10.2-6       Embedded GNU C Library: Shared lib
ii  libfontconfig1            2.8.0-2        generic font configuration library
ii  libice6                   2:1.0.6-1      X11 Inter-Client Exchange library
ii  libncurses5               5.7+20100313-1 shared libraries for terminal hand
ii  libutempter0              1.1.5-2        A privileged helper for utmp/wtmp 
ii  libx11-6                  2:1.3.3-2      X11 client-side library
ii  libxaw7                   2:1.0.7-1      X11 Athena Widget library
ii  libxft2                   2.1.14-2       FreeType-based font drawing librar
ii  libxmu6                   2:1.0.5-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.7-1      X11 toolkit intrinsics library
ii  xbitmaps                  1.1.0-1        Base X bitmaps

Versions of packages xterm recommends:
ii  x11-utils                     7.5+3      X11 utilities
ii  xutils                        1:7.5+5    X Window System utility programs m

Versions of packages xterm suggests:
ii  xfonts-cyrillic               1:1.0.1    Cyrillic fonts for X

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Wed, 17 Mar 2010 23:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 17 Mar 2010 23:57:06 GMT) Full text and rfc822 format available.

Message #10 received at 574396@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 574396@bugs.debian.org
Cc: 574396-submitter@bugs.debian.org
Subject: re: #574396 xterm: meta no longer sends escape even with eightBitInput: false
Date: Wed, 17 Mar 2010 19:54:49 -0400
[Message part 1 (text/plain, inline)]
The feature seems to work here (compiled myself...).  I'd assume it's
a resource setting; the output of "appres XTerm" might show it.

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to "Aaron M. Ucko" <ucko@debian.org>:
Bug#574396. (Wed, 17 Mar 2010 23:57:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Thu, 18 Mar 2010 00:24:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to amu@alum.mit.edu (Aaron M. Ucko):
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 18 Mar 2010 00:24:06 GMT) Full text and rfc822 format available.

Message #18 received at 574396@bugs.debian.org (full text, mbox):

From: amu@alum.mit.edu (Aaron M. Ucko)
To: dickey@his.com
Cc: 574396-quiet@bugs.debian.org, 574396@bugs.debian.org, 574396-submitter@bugs.debian.org
Subject: Re: Bug#574396: #574396 xterm: meta no longer sends escape even with eightBitInput: false
Date: Wed, 17 Mar 2010 20:21:05 -0400
[Message part 1 (text/plain, inline)]
Thomas Dickey <dickey@his.com> writes:

> The feature seems to work here (compiled myself...).  I'd assume it's
> a resource setting; the output of "appres XTerm" might show it.

Thanks for the quick response!  I wondered about that too, but didn't
notice anything suspicious in the (attached) output.

-- 
Aaron M. Ucko, KB1CJC (amu at alum.mit.edu, ucko at debian.org)
http://www.mit.edu/~amu/ | http://stuff.mit.edu/cgi/finger/?amu@monk.mit.edu

[xterm-resources.txt (text/plain, inline)]
*SimpleMenu*menuLabel.font:	-adobe-helvetica-bold-r-normal--*-120-*-*-*-*-iso8859-*
*SimpleMenu*menuLabel.vertSpace:	100
*SimpleMenu*Sme.height:	16
*SimpleMenu*background:	AntiqueWhite
*SimpleMenu*borderWidth:	2
*SimpleMenu*Cursor:	left_ptr
*SimpleMenu*BackingStore:	NotUseful
*SimpleMenu*foreground:	gray15
*SimpleMenu*HorizontalMargins:	16
*fontMenu*font-packed*Label:	Packed Font
*fontMenu*font4*Label:	Medium
*fontMenu*allow-window-ops*Label:	Allow Window Ops
*fontMenu*render-font*Label:	TrueType Fonts
*fontMenu*font5*Label:	Large
*fontMenu*utf8-mode*Label:	UTF-8
*fontMenu*font6*Label:	Huge
*fontMenu*utf8-title*Label:	UTF-8 Titles
*fontMenu*fontdefault*Label:	Default
*fontMenu*fontescape*Label:	Escape Sequence
*fontMenu*allow-color-ops*Label:	Allow Color Ops
*fontMenu*font1*Label:	Unreadable
*fontMenu*fontsel*Label:	Selection
*fontMenu*font-linedrawing*Label:	Line-Drawing Characters
*fontMenu*allow-font-ops*Label:	Allow Font Ops
*fontMenu*font-doublesize*Label:	Doublesized Characters
*fontMenu*font2*Label:	Tiny
*fontMenu*allow-tcap-ops*Label:	Allow Termcap Ops
*fontMenu*font-loadable*Label:	VT220 Soft Fonts
*fontMenu*font3*Label:	Small
*fontMenu*allow-title-ops*Label:	Allow Title Ops
*fontMenu.Label:	VT Fonts
*fontMenu*background:	AntiqueWhite
*fontMenu*foreground:	gray15
*XmText*translations:	#override <Key>BackSpace: delete-previous-character() \n\
 <Key>Delete: delete-next-character() \n\
 <Key>osfBackSpace: delete-previous-character() \n\
 <Key>osfDelete: delete-next-character()
*XmTextField*translations:	#override <Key>BackSpace: delete-previous-character() \n\
 <Key>Delete: delete-next-character() \n\
 <Key>osfBackSpace: delete-previous-character() \n\
 <Key>osfDelete: delete-next-character()
*XmtInputField*translations:	#override <Key>BackSpace: delete-previous-character() \n\
 <Key>Delete: delete-next-character() \n\
 <Key>osfBackSpace: delete-previous-character() \n\
 <Key>osfDelete: delete-next-character()
*tek4014*fontLarge:	9x15
*tek4014*font2:	8x13
*tek4014*font3:	6x13
*tek4014*fontSmall:	6x10
*vtMenu*scrollttyoutput*Label:	Scroll to Bottom on Tty Output
*vtMenu*jumpscroll*Label:	Enable Jump Scroll
*vtMenu*cursorblink*Label:	Enable Blinking Cursor
*vtMenu*vthide*Label:	Hide VT Window
*vtMenu*allow132*Label:	Allow 80/132 Column Switching
*vtMenu*reversevideo*Label:	Enable Reverse Video
*vtMenu*titeInhibit*Label:	Enable Alternate Screen Switching
*vtMenu*altscreen*Label:	Show Alternate Screen
*vtMenu*keepSelection*Label:	Keep Selection
*vtMenu*autowrap*Label:	Enable Auto Wraparound
*vtMenu*activeicon*Label:	Enable Active Icon
*vtMenu*selectToClipboard*Label:	Select to Clipboard
*vtMenu*reversewrap*Label:	Enable Reverse Wraparound
*vtMenu*softreset*Label:	Do Soft Reset
*vtMenu*cursesemul*Label:	Enable Curses Emulation
*vtMenu*autolinefeed*Label:	Enable Auto Linefeed
*vtMenu*hardreset*Label:	Do Full Reset
*vtMenu*visualbell*Label:	Enable Visual Bell
*vtMenu*appcursor*Label:	Enable Application Cursor Keys
*vtMenu*clearsavedlines*Label:	Reset and Clear Saved Lines
*vtMenu*bellIsUrgent*Label:	Enable Bell Urgency
*vtMenu*appkeypad*Label:	Enable Application Keypad
*vtMenu*tekshow*Label:	Show Tek Window
*vtMenu*poponbell*Label:	Enable Pop on Bell
*vtMenu*scrollbar*Label:	Enable Scrollbar
*vtMenu*scrollkey*Label:	Scroll to Bottom on Key Press
*vtMenu*tekmode*Label:	Switch to Tek Mode
*vtMenu.Label:	VT Options
*vtMenu*background:	AntiqueWhite
*vtMenu*foreground:	gray15
*mainMenu*delete-is-del*Label:	Delete is DEL
*mainMenu*print-redir*Label:	Redirect to Printer
*mainMenu*continue*Label:	Send CONT Signal
*mainMenu*oldFunctionKeys*Label:	Old Function-Keys
*mainMenu*interrupt*Label:	Send INT Signal
*mainMenu*sunFunctionKeys*Label:	Sun Function-Keys
*mainMenu*toolbar*Label:	Toolbar
*mainMenu*8-bit control*Label:	8-Bit Controls
*mainMenu*hangup*Label:	Send HUP Signal
*mainMenu*sunKeyboard*Label:	VT220 Keyboard
*mainMenu*securekbd*Label:	Secure Keyboard
*mainMenu*terminate*Label:	Send TERM Signal
*mainMenu*hpFunctionKeys*Label:	HP Function-Keys
*mainMenu*allowsends*Label:	Allow SendEvents
*mainMenu*backarrow key*Label:	Backarrow Key (BS/DEL)
*mainMenu*kill*Label:	Send KILL Signal
*mainMenu*num-lock*Label:	Alt/NumLock Modifiers
*mainMenu*redraw*Label:	Redraw Window
*mainMenu*scoFunctionKeys*Label:	SCO Function-Keys
*mainMenu*quit*Label:	Quit
*mainMenu*alt-esc*Label:	Alt Sends Escape
*mainMenu*logging*Label:	Log to File
*mainMenu*tcapFunctionKeys*Label:	Termcap Function-Keys
*mainMenu*meta-esc*Label:	Meta Sends Escape
*mainMenu*print*Label:	Print Window
*mainMenu*suspend*Label:	Send STOP Signal
*mainMenu.Label:	Main Options
*mainMenu*background:	AntiqueWhite
*mainMenu*foreground:	gray15
*tekMenu*tekreset*Label:	RESET
*tekMenu*tektext2*Label:	#2 Size Characters
*tekMenu*tekhide*Label:	Hide Tek Window
*tekMenu*tekcopy*Label:	COPY
*tekMenu*tektext3*Label:	#3 Size Characters
*tekMenu*vtshow*Label:	Show VT Window
*tekMenu*tektextsmall*Label:	Small Characters
*tekMenu*vtmode*Label:	Switch to VT Mode
*tekMenu*tektextlarge*Label:	Large Characters
*tekMenu*tekpage*Label:	PAGE
*tekMenu.Label:	Tek Options
*tekMenu*background:	AntiqueWhite
*tekMenu*foreground:	gray15
*form.Thickness:	0
*form.background:	AntiqueWhite
*VT100.utf8Fonts.font4:	-misc-fixed-medium-r-normal--13-120-75-75-c-80-iso10646-1
*VT100.utf8Fonts.font2:	-misc-fixed-medium-r-normal--8-80-75-75-c-50-iso10646-1
*VT100.utf8Fonts.font6:	-misc-fixed-medium-r-normal--20-200-75-75-c-100-iso10646-1
*VT100.utf8Fonts.font5:	-misc-fixed-medium-r-normal--18-120-100-100-c-90-iso10646-1
*VT100.utf8Fonts.font3:	-misc-fixed-medium-r-normal--14-130-75-75-c-70-iso10646-1
*VT100.utf8Fonts.font:	-misc-fixed-medium-r-semicondensed--13-120-75-75-c-60-iso10646-1
*VT100.scrollbar.borderWidth:	0
*VT100.scrollbar.foreground:	rgb:a/5/5
*VT100.scrollbar.background:	gray60
*VT100.scrollbar.thumb:	vlines2
*VT100.scrollbar.displayList:	foreground      gray90;lines           1,-1,-1,-1,-1,1;foreground      gray60;lines           -1,0,0,0,0,-1
*VT100.scrollbar.width:	14
*VT100*background:	black
*VT100.font4:	7x13
*VT100*dynamicColors:	on
*VT100*color5:	magenta3
*VT100*color11:	yellow
*VT100.font5:	9x15
*VT100*color6:	cyan3
*VT100*color12:	rgb:5c/5c/ff
*VT100*foreground:	gray90
*VT100.font6:	10x20
*VT100*color7:	gray90
*VT100*color13:	magenta
*VT100*color8:	gray50
*VT100*color14:	cyan
*VT100.font1:	nil2
*VT100*color9:	red
*VT100*color15:	white
*VT100*color2:	green3
*VT100*color0:	black
*VT100*colorBD:	white
*VT100*color3:	yellow3
*VT100*color1:	red3
*VT100.font2:	5x7
*VT100*boldColors:	on
*VT100*colorUL:	yellow
*VT100.font3:	6x10
*VT100*colorMode:	on
*VT100*color4:	blue2
*VT100*color10:	green
*menubar.borderWidth:	0
*MenuButton*borderWidth:	0
*Form.menubar.background:	AntiqueWhite
*Form.menubar*background:	AntiqueWhite
*Form.menubar.foreground:	gray15
*Form.menubar*foreground:	gray15
*Form.background:	AntiqueWhite
XTerm*VT100.Translations:	#override \n\
 ~Shift ~Ctrl ~Meta <Key>BackSpace: string("\177")\n\
 ~Shift ~Ctrl ~Meta <Key>Delete: string("\033[3~")\n\
 ~Shift ~Ctrl ~Meta <Key>Home: string("\033[1~")\n\
 ~Shift ~Ctrl ~Meta <Key>End: string("\033[4~")\n\
 ~Shift ~Ctrl Meta <Key>Delete: string("\033\177") \n\
 ~Shift ~Ctrl Meta <Key>BackSpace: string("\033\177") \n\
 Shift ~Ctrl ~Meta <Btn2Up>: insert-selection(PRIMARY, CUT_BUFFER0) \n\
 ~Shift ~Ctrl ~Meta <Btn2Up>: ignore() \n
XTerm*VT100.background:	black
XTerm*VT100.foreground:	gray70
XTerm*color5:	magenta2
XTerm*color11:	LightGoldenrod1
XTerm*dynamicColors:	on
XTerm*color6:	dark cyan
XTerm*color12:	cornflower blue
XTerm*eightBitInput:	false
XTerm*font:	fixed
XTerm*color7:	gray70
XTerm*color13:	MediumOrchid1
XTerm*saveLines:	1000
XTerm*color8:	gray50
XTerm*color14:	CadetBlue1
XTerm*scrollBar:	false
XTerm*color9:	tomato
XTerm*color15:	white
XTerm*cursorColor:	gray70
XTerm*color2:	green4
XTerm*color0:	black
XTerm*color3:	DarkOrange2
XTerm*color1:	red
XTerm*boldFont:	fixedb
XTerm*color4:	blue
XTerm*color10:	SeaGreen2
XTerm*colorMode:	on
*backarrowKeyIsErase:	true
*saveLines:	1024
*customization:	-color
*ptyInitialErase:	true
*IconFont:	nil2
*beNiceToColormap:	False

Information stored :
Bug#574396; Package xterm. (Thu, 18 Mar 2010 00:24:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to amu@alum.mit.edu (Aaron M. Ucko):
Extra info received and filed, but not forwarded. (Thu, 18 Mar 2010 00:24:08 GMT) Full text and rfc822 format available.

Message sent on to "Aaron M. Ucko" <ucko@debian.org>:
Bug#574396. (Thu, 18 Mar 2010 00:24:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Thu, 18 Mar 2010 01:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 18 Mar 2010 01:18:05 GMT) Full text and rfc822 format available.

Message #31 received at 574396@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: "Aaron M. Ucko" <amu@alum.mit.edu>
Cc: 574396@bugs.debian.org, 574396-submitter@bugs.debian.org
Subject: Re: Bug#574396: #574396 xterm: meta no longer sends escape even with eightBitInput: false
Date: Wed, 17 Mar 2010 21:08:25 -0400 (EDT)
On Wed, 17 Mar 2010, Aaron M. Ucko wrote:

> Thomas Dickey <dickey@his.com> writes:
>
>> The feature seems to work here (compiled myself...).  I'd assume it's
>> a resource setting; the output of "appres XTerm" might show it.
>
> Thanks for the quick response!  I wondered about that too, but didn't
> notice anything suspicious in the (attached) output.

I don't see, either.  Just running my build against the resource file 
works okay, so it's not _there_.  Also, I built an xterm using the options
from the Debian package, and it still seems to work.

But in the past couple of weeks, I've been installing a new machine, and 
noticed -on a couple of other Linux's- that there's some breakage in luit 
which may be related (if you didn't happen to have the Latin-1 locale 
installed, for instance).

Another thought - depends on what your meta key is.  I've gotten two 
recent reports which deal with a change I made a few years ago, to 
suppress use of the meta (or alt) key by xterm if they appear in a 
translations resource.  A quick check seems to show the last change there 
in mid-2008 (patch #238).

If it's not that, then it might help to know the older (good) version of 
xterm. It looks like about a year since I made any interesting changes to 
the input.c file, which would be where this is implemented.

(generally when I'm down to this point, it also helps to get a debug 
trace).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Message sent on to "Aaron M. Ucko" <ucko@debian.org>:
Bug#574396. (Thu, 18 Mar 2010 01:18:15 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Thu, 18 Mar 2010 04:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to ucko@debian.org (Aaron M. Ucko):
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 18 Mar 2010 04:06:02 GMT) Full text and rfc822 format available.

Message #39 received at 574396@bugs.debian.org (full text, mbox):

From: ucko@debian.org (Aaron M. Ucko)
To: Thomas Dickey <dickey@his.com>
Cc: 574396@bugs.debian.org, ucko@debian.org
Subject: Re: Bug#574396: #574396 xterm: meta no longer sends escape even with eightBitInput: false
Date: Thu, 18 Mar 2010 00:04:02 -0400
Thomas Dickey <dickey@his.com> writes:

> But in the past couple of weeks, I've been installing a new machine, and noticed -on a couple of other Linux's- that there's some breakage
> in luit which may be related (if you didn't happen to have the Latin-1 locale installed, for instance).

I use a UTF-8 locale, so luit isn't involved.  Further investigation
revealed that the relevant upgrade was not of xterm (from version 255,
FTR) but of ncurses-base; the addition of rmm and smm settings to
xterm's terminfo entry somehow caused xterm to ignore the
eightBitInput resource.  (There are some other differences as well,
mostly in k* settings, but those look most likely to be the culprit.)

I'm leaving this bug assigned to xterm anyway, both because I'm not
convinced that that change should have had such an effect and because
ncurses gets its xterm terminfo definition from xterm's sources.  (The
latest update claims to have taken xterm-246's definition.)

-- 
Aaron M. Ucko, KB1CJC (amu at alum.mit.edu, ucko at debian.org)
http://www.mit.edu/~amu/ | http://stuff.mit.edu/cgi/finger/?amu@monk.mit.edu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Thu, 18 Mar 2010 04:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to ucko@debian.org (Aaron M. Ucko):
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 18 Mar 2010 04:36:03 GMT) Full text and rfc822 format available.

Message #44 received at 574396@bugs.debian.org (full text, mbox):

From: ucko@debian.org (Aaron M. Ucko)
To: ucko@debian.org (Aaron M. Ucko)
Cc: Thomas Dickey <dickey@his.com>, 574396@bugs.debian.org
Subject: Re: Bug#574396: #574396 xterm: meta no longer sends escape even with eightBitInput: false
Date: Thu, 18 Mar 2010 00:32:51 -0400
ucko@debian.org (Aaron M. Ucko) writes:

> FTR) but of ncurses-base; the addition of rmm and smm settings to

It belatedly occurred to me that the issue is likelier indirect, with
bash for some reason picking up on that and forcing xterm into the
wrong mode. :-/  I don't have time to investigate further tonight,
though.

-- 
Aaron M. Ucko, KB1CJC (amu at alum.mit.edu, ucko at debian.org)
http://www.mit.edu/~amu/ | http://stuff.mit.edu/cgi/finger/?amu@monk.mit.edu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Thu, 18 Mar 2010 08:18:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 18 Mar 2010 08:18:10 GMT) Full text and rfc822 format available.

Message #49 received at 574396@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: "Aaron M. Ucko" <ucko@debian.org>
Cc: 574396@bugs.debian.org
Subject: Re: Bug#574396: #574396 xterm: meta no longer sends escape even with eightBitInput: false
Date: Thu, 18 Mar 2010 04:10:58 -0400 (EDT)
On Thu, 18 Mar 2010, Aaron M. Ucko wrote:

> Thomas Dickey <dickey@his.com> writes:
>
>> But in the past couple of weeks, I've been installing a new machine, and noticed -on a couple of other Linux's- that there's some breakage
>> in luit which may be related (if you didn't happen to have the Latin-1 locale installed, for instance).
>
> I use a UTF-8 locale, so luit isn't involved.  Further investigation
> revealed that the relevant upgrade was not of xterm (from version 255,
> FTR) but of ncurses-base; the addition of rmm and smm settings to
> xterm's terminfo entry somehow caused xterm to ignore the
> eightBitInput resource.  (There are some other differences as well,
> mostly in k* settings, but those look most likely to be the culprit.)

That's already been discussed in SuSE - it's an issue with bash.
It should allow the decision whether to enable meta mode to be 
configurable.  bash's maintainer hasn't been cooperative.

see
	http://invisible-island.net/xterm/xterm.log.html#xterm_21

(the interaction with bash's maintainer, unfortunately, is mostly in
private email among me and the SuSE maintainers)

> I'm leaving this bug assigned to xterm anyway, both because I'm not
> convinced that that change should have had such an effect and because
> ncurses gets its xterm terminfo definition from xterm's sources.  (The
> latest update claims to have taken xterm-246's definition.)


-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#574396; Package xterm. (Thu, 18 Mar 2010 19:09:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to ucko@debian.org (Aaron M. Ucko):
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 18 Mar 2010 19:09:05 GMT) Full text and rfc822 format available.

Message #54 received at 574396@bugs.debian.org (full text, mbox):

From: ucko@debian.org (Aaron M. Ucko)
To: 574396@bugs.debian.org
Cc: "Aaron M. Ucko" <ucko@debian.org>, Thomas Dickey <dickey@his.com>, Matthias Klose <doko@debian.org>, control@bugs.debian.org, 444250@bugs.debian.org
Subject: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Thu, 18 Mar 2010 15:07:45 -0400
retitle 574396 please set enable-meta-key (_rl_enable_meta) sanely
reassign 574396 bash 4.1-2
clone 574396 -1
reassign -1 libreadline6 6.1-1
thanks

[Summary for newly added recipients: after a recent round of upgrades, I
found that typing meta-key combinations into xterm with bash as my shell
resulted in non-ASCII characters rather than the expected escape sequences.
Further analysis revealed that the trigger was an update to xterm's terminfo
entry (from ncurses-base), which added definitions of smm and rmm despite
the comment in http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=444250#40 .]

Thomas Dickey <dickey@his.com> writes:

> That's already been discussed in SuSE - it's an issue with bash.
> It should allow the decision whether to enable meta mode to be
> configurable.  bash's maintainer hasn't been cooperative.

As of bash 4.1 (and the corresponding readline 6.1 release), there is now an
enable-meta-key readline variable that has the desired effect.  Bash and
readline have logic (_rl_init_eightbit) to set related variables
(convert-meta, input-meta, and output-meta) sanely in eight-bit locales, but
always leave enable-meta-key on by default; could you please patch
_rl_init_eightbit to set _rl_enable_meta = 0 in eight-bit mode?

Thanks!

> 	http://invisible-island.net/xterm/xterm.log.html#xterm_21

ITYM http://invisible-island.net/xterm/xterm.log.html#xterm_216 .

-- 
Aaron M. Ucko, KB1CJC (amu at alum.mit.edu, ucko at debian.org)
http://www.mit.edu/~amu/ | http://stuff.mit.edu/cgi/finger/?amu@monk.mit.edu




Changed Bug title to 'please set enable-meta-key (_rl_enable_meta) sanely' from 'xterm: meta no longer sends escape even with eightBitInput: false' Request was from ucko@debian.org (Aaron M. Ucko) to control@bugs.debian.org. (Thu, 18 Mar 2010 19:09:13 GMT) Full text and rfc822 format available.

Bug reassigned from package 'xterm' to 'bash'. Request was from ucko@debian.org (Aaron M. Ucko) to control@bugs.debian.org. (Thu, 18 Mar 2010 19:09:14 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions xterm/256-1. Request was from ucko@debian.org (Aaron M. Ucko) to control@bugs.debian.org. (Thu, 18 Mar 2010 19:09:15 GMT) Full text and rfc822 format available.

Bug Marked as found in versions bash/4.1-2. Request was from ucko@debian.org (Aaron M. Ucko) to control@bugs.debian.org. (Thu, 18 Mar 2010 19:09:15 GMT) Full text and rfc822 format available.

Bug 574396 cloned as bug 574518. Request was from ucko@debian.org (Aaron M. Ucko) to control@bugs.debian.org. (Thu, 18 Mar 2010 19:09:16 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#574396; Package bash. (Fri, 19 Mar 2010 07:57:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Fri, 19 Mar 2010 07:57:12 GMT) Full text and rfc822 format available.

Message #69 received at 574396@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: ucko@debian.org (Aaron M. Ucko)
Cc: 444250@bugs.debian.org, 574396@bugs.debian.org, Thomas Dickey <dickey@his.com>, Matthias Klose <doko@debian.org>
Subject: Re: Bug#444250: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Fri, 19 Mar 2010 08:54:35 +0100
On 2010-03-18 20:07 +0100, Aaron M. Ucko wrote:

> retitle 574396 please set enable-meta-key (_rl_enable_meta) sanely
> reassign 574396 bash 4.1-2
> clone 574396 -1
> reassign -1 libreadline6 6.1-1
> thanks
>
> [Summary for newly added recipients: after a recent round of upgrades, I
> found that typing meta-key combinations into xterm with bash as my shell
> resulted in non-ASCII characters rather than the expected escape sequences.
> Further analysis revealed that the trigger was an update to xterm's terminfo
> entry (from ncurses-base), which added definitions of smm and rmm despite
> the comment in http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=444250#40 .]

I'm sorry for the problems this caused for you; when I tested the
updated xterm terminfo I could not figure out the difference with
smm/rmm enabled or disabled, and over time I forgot about the issue.

Now after reading #574396 I see that with the xterm resources

xterm*metaSendsEscape: false
xterm*eightBitInput: false

and bash as shell meta-key combinations yield non-ASCII characters,
which is not the case when the smm/rmm features are disabled.

> Thomas Dickey <dickey@his.com> writes:
>
>> That's already been discussed in SuSE - it's an issue with bash.
>> It should allow the decision whether to enable meta mode to be
>> configurable.  bash's maintainer hasn't been cooperative.
>
> As of bash 4.1 (and the corresponding readline 6.1 release), there is now an
> enable-meta-key readline variable that has the desired effect.  Bash and
> readline have logic (_rl_init_eightbit) to set related variables
> (convert-meta, input-meta, and output-meta) sanely in eight-bit locales, but
> always leave enable-meta-key on by default; could you please patch
> _rl_init_eightbit to set _rl_enable_meta = 0 in eight-bit mode?

Regardless of that I think we should disable smm and rmm features for
squeeze to avoid breakage on partial upgrades.  If bash gets fixed, we
can enable them after the release.

Sven




Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#574396; Package bash. (Fri, 19 Mar 2010 17:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Fri, 19 Mar 2010 17:18:06 GMT) Full text and rfc822 format available.

Message #74 received at 574396@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: 444250@bugs.debian.org
Cc: ucko@debian.org (Aaron M. Ucko), 574396@bugs.debian.org, Thomas Dickey <dickey@his.com>, Matthias Klose <doko@debian.org>
Subject: Re: Bug#444250: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Fri, 19 Mar 2010 18:15:01 +0100
On 2010-03-19 08:54 +0100, Sven Joachim wrote:

> Regardless of that I think we should disable smm and rmm features for
> squeeze to avoid breakage on partial upgrades.  If bash gets fixed, we
> can enable them after the release.

I pushed this change to ncurses git:
http://git.debian.org/?p=collab-maint/ncurses.git;a=commitdiff;h=487665a5dfb2a1ce5ab6c64ed2f3f54dd06652ce

Sven




Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#574396; Package bash. (Tue, 23 Mar 2010 22:15:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to chet.ramey@case.edu:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Tue, 23 Mar 2010 22:15:14 GMT) Full text and rfc822 format available.

Message #79 received at 574396@bugs.debian.org (full text, mbox):

From: Chet Ramey <chet.ramey@case.edu>
To: ucko@debian.org
Cc: 574396@bugs.debian.org, ucko@debian.org, dickey@his.com, doko@debian.org, control@bugs.debian.org, 444250@bugs.debian.org, chet@po.cwru.edu
Subject: Re: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Tue, 23 Mar 2010 17:47:15 -0400
> [Summary for newly added recipients: after a recent round of upgrades, I
> found that typing meta-key combinations into xterm with bash as my shell
> resulted in non-ASCII characters rather than the expected escape sequences.
> Further analysis revealed that the trigger was an update to xterm's terminfo
> entry (from ncurses-base), which added definitions of smm and rmm despite
> the comment in http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=444250#40 .]
> 
> Thomas Dickey <dickey@his.com> writes:
> 
> > That's already been discussed in SuSE - it's an issue with bash.
> > It should allow the decision whether to enable meta mode to be
> > configurable.  bash's maintainer hasn't been cooperative.
> 
> As of bash 4.1 (and the corresponding readline 6.1 release), there is now an
> enable-meta-key readline variable that has the desired effect.  Bash and
> readline have logic (_rl_init_eightbit) to set related variables
> (convert-meta, input-meta, and output-meta) sanely in eight-bit locales, but
> always leave enable-meta-key on by default; could you please patch
> _rl_init_eightbit to set _rl_enable_meta = 0 in eight-bit mode?

Why would I want to turn off _rl_enable_meta in eight-bit mode?  It
seems that's when I should want it, since it's supposed to reflect the
terminal's indicating that any available meta key enables the sending
of eight-bit characters when it's used.

For this issue to exist, the terminal has to advertise (using "km")
that it has a meta key that turns on the eighth bit of characters the
terminal sends when it's used as a modifier, and the "smm" capability
has to exist to enable it.  If those are both true, and the
enable-meta variable is set, which it is by default, bash sends the
"smm" string.  If I'm in eight-bit mode, I want that to be on. 

I sent a bunch of questions last year about how xterm advertises
capabilities using terminfo and how it reacts when it gets the
corresponding escape sequences; those were ignored.  I'm still
waiting. 

Remember that the only way bash or any application can get to the
xterm resources is through terminfo/termcap.  If understanding the
interaction between the two requires some remedial instruction, fire
away.

Chet

-- 
``The lyf so short, the craft so long to lerne.'' - Chaucer
		 ``Ars longa, vita brevis'' - Hippocrates
Chet Ramey, ITS, CWRU    chet@case.edu    http://cnswww.cns.cwru.edu/~chet/




Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#574396; Package bash. (Tue, 23 Mar 2010 22:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Tue, 23 Mar 2010 22:21:05 GMT) Full text and rfc822 format available.

Message #84 received at 574396@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Chet Ramey <chet.ramey@case.edu>
Cc: 574396@bugs.debian.org, chet@po.cwru.edu
Subject: Re: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Tue, 23 Mar 2010 18:18:32 -0400 (EDT)
On Tue, 23 Mar 2010, Chet Ramey wrote:

> I sent a bunch of questions last year about how xterm advertises
> capabilities using terminfo and how it reacts when it gets the
> corresponding escape sequences; those were ignored.  I'm still
> waiting.

I don't see a "bunch of questions", but only about 3 lines of comments 
which most people would answer by reading the manpage (start with the
resource description for eightBitInput).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#574396; Package bash. (Wed, 24 Mar 2010 00:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to chet.ramey@case.edu:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Wed, 24 Mar 2010 00:12:04 GMT) Full text and rfc822 format available.

Message #89 received at 574396@bugs.debian.org (full text, mbox):

From: Chet Ramey <chet.ramey@case.edu>
To: Thomas Dickey <dickey@his.com>
Cc: 574396@bugs.debian.org, chet@po.cwru.edu
Subject: Re: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Tue, 23 Mar 2010 20:09:50 -0400
On 3/23/10 6:18 PM, Thomas Dickey wrote:

> I don't see a "bunch of questions", but only about 3 lines of comments
> which most people would answer by reading the manpage (start with the
> resource description for eightBitInput).

Singularly unhelpful.

-- 
``The lyf so short, the craft so long to lerne.'' - Chaucer
		 ``Ars longa, vita brevis'' - Hippocrates
Chet Ramey, ITS, CWRU    chet@case.edu    http://cnswww.cns.cwru.edu/~chet/




Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#574396; Package bash. (Thu, 25 Mar 2010 15:24:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to chet.ramey@case.edu:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Thu, 25 Mar 2010 15:24:08 GMT) Full text and rfc822 format available.

Message #94 received at 574396@bugs.debian.org (full text, mbox):

From: Chet Ramey <chet.ramey@case.edu>
To: Thomas Dickey <dickey@his.com>
Cc: ucko@debian.org, 444250@bugs.debian.org, chet.ramey@case.edu, 574396@bugs.debian.org
Subject: Re: Bug#444250: Bug#574396: please set enable-meta-key (_rl_enable_meta) sanely
Date: Thu, 25 Mar 2010 11:22:15 -0400
On 3/23/10 9:28 PM, Thomas Dickey wrote:

>> Given that, the issue is now how to appropriately set the default
>> value of
>> the enable-meta variable.  That's the current question, and it was the
>> question we were considering before.
> 
> Like the choice of $TERM, it's something that the user is going to have
> to decide.  It might be dynamic.

OK, thanks for your help.  We've come full circle.  I don't see any reason
to change the status quo.

Chet


-- 
``The lyf so short, the craft so long to lerne.'' - Chaucer
		 ``Ars longa, vita brevis'' - Hippocrates
Chet Ramey, ITS, CWRU    chet@case.edu    http://cnswww.cns.cwru.edu/~chet/




Forcibly Merged 574396 577010. Request was from Thomas Dickey <dickey@his.com> to control@bugs.debian.org. (Sat, 24 Apr 2010 14:39:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 20:15:59 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.